//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// TempsDlg.cpp : implementation file

#include "stdafx.h"
#include "533I2C_wintest.h"
#include "I2C.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "533I2C_WinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TempsDlg dialog
/////////////////////////////////////////////////////////////////////////////
#define POLL_INTERVAL 100 // 1/10 sec
#define ID_TIMER2     2
/////////////////////////////////////////////////////////////////////////////
TempsDlg::TempsDlg(CWnd* pParent /*=NULL*/)
  : CDialog(TempsDlg::IDD, pParent)
  {
  //{{AFX_DATA_INIT(TempsDlg)
  //}}AFX_DATA_INIT
  ASSERT(pParent != NULL);

  m_pParent = pParent;
  m_nID = TempsDlg::IDD;
  }

BOOL TempsDlg::OnInitDialog()
  {
  CDialog::OnInitDialog();

  int
    i;
  for(i=0;i<=31;i++)
    time_since_new_data[i]=0;

  StartTimer(POLL_INTERVAL);

  boot_is_at_our_request=0;

  return TRUE;
  }

void TempsDlg::DoDataExchange(CDataExchange* pDX)
  {
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(TempsDlg)
  DDX_Control(pDX, IDC_ENABLE_TEMP_01, m_enable_temps[0]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_02, m_enable_temps[1]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_03, m_enable_temps[2]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_04, m_enable_temps[3]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_05, m_enable_temps[4]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_06, m_enable_temps[5]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_07, m_enable_temps[6]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_08, m_enable_temps[7]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_09, m_enable_temps[8]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_10, m_enable_temps[9]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_11, m_enable_temps[10]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_12, m_enable_temps[11]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_13, m_enable_temps[12]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_14, m_enable_temps[13]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_15, m_enable_temps[14]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_16, m_enable_temps[15]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_17, m_enable_temps[16]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_18, m_enable_temps[17]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_19, m_enable_temps[18]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_20, m_enable_temps[19]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_21, m_enable_temps[20]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_22, m_enable_temps[21]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_23, m_enable_temps[22]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_24, m_enable_temps[23]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_25, m_enable_temps[24]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_26, m_enable_temps[25]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_27, m_enable_temps[26]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_28, m_enable_temps[27]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_29, m_enable_temps[28]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_30, m_enable_temps[29]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_31, m_enable_temps[30]);
  DDX_Control(pDX, IDC_ENABLE_TEMP_32, m_enable_temps[31]);

  DDX_Control(pDX, IDC_DEG_F_TEMP_01, m_deg_f_temps[0]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_02, m_deg_f_temps[1]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_03, m_deg_f_temps[2]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_04, m_deg_f_temps[3]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_05, m_deg_f_temps[4]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_06, m_deg_f_temps[5]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_07, m_deg_f_temps[6]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_08, m_deg_f_temps[7]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_09, m_deg_f_temps[8]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_10, m_deg_f_temps[9]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_11, m_deg_f_temps[10]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_12, m_deg_f_temps[11]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_13, m_deg_f_temps[12]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_14, m_deg_f_temps[13]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_15, m_deg_f_temps[14]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_16, m_deg_f_temps[15]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_17, m_deg_f_temps[16]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_18, m_deg_f_temps[17]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_19, m_deg_f_temps[18]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_20, m_deg_f_temps[19]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_21, m_deg_f_temps[20]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_22, m_deg_f_temps[21]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_23, m_deg_f_temps[22]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_24, m_deg_f_temps[23]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_25, m_deg_f_temps[24]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_26, m_deg_f_temps[25]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_27, m_deg_f_temps[26]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_28, m_deg_f_temps[27]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_29, m_deg_f_temps[28]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_30, m_deg_f_temps[29]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_31, m_deg_f_temps[30]);
  DDX_Control(pDX, IDC_DEG_F_TEMP_32, m_deg_f_temps[31]);

  DDX_Control(pDX, IDC_DEG_C_TEMP_01, m_deg_c_temps[0]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_02, m_deg_c_temps[1]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_03, m_deg_c_temps[2]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_04, m_deg_c_temps[3]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_05, m_deg_c_temps[4]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_06, m_deg_c_temps[5]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_07, m_deg_c_temps[6]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_08, m_deg_c_temps[7]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_09, m_deg_c_temps[8]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_10, m_deg_c_temps[9]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_11, m_deg_c_temps[10]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_12, m_deg_c_temps[11]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_13, m_deg_c_temps[12]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_14, m_deg_c_temps[13]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_15, m_deg_c_temps[14]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_16, m_deg_c_temps[15]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_17, m_deg_c_temps[16]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_18, m_deg_c_temps[17]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_19, m_deg_c_temps[18]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_20, m_deg_c_temps[19]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_21, m_deg_c_temps[20]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_22, m_deg_c_temps[21]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_23, m_deg_c_temps[22]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_24, m_deg_c_temps[23]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_25, m_deg_c_temps[24]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_26, m_deg_c_temps[25]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_27, m_deg_c_temps[26]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_28, m_deg_c_temps[27]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_29, m_deg_c_temps[28]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_30, m_deg_c_temps[29]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_31, m_deg_c_temps[30]);
  DDX_Control(pDX, IDC_DEG_C_TEMP_32, m_deg_c_temps[31]);

  DDX_Control(pDX, IDC_DOW_ID_01, m_dow_ids[0]);
  DDX_Control(pDX, IDC_DOW_ID_02, m_dow_ids[1]);
  DDX_Control(pDX, IDC_DOW_ID_03, m_dow_ids[2]);
  DDX_Control(pDX, IDC_DOW_ID_04, m_dow_ids[3]);
  DDX_Control(pDX, IDC_DOW_ID_05, m_dow_ids[4]);
  DDX_Control(pDX, IDC_DOW_ID_06, m_dow_ids[5]);
  DDX_Control(pDX, IDC_DOW_ID_07, m_dow_ids[6]);
  DDX_Control(pDX, IDC_DOW_ID_08, m_dow_ids[7]);
  DDX_Control(pDX, IDC_DOW_ID_09, m_dow_ids[8]);
  DDX_Control(pDX, IDC_DOW_ID_10, m_dow_ids[9]);
  DDX_Control(pDX, IDC_DOW_ID_11, m_dow_ids[10]);
  DDX_Control(pDX, IDC_DOW_ID_12, m_dow_ids[11]);
  DDX_Control(pDX, IDC_DOW_ID_13, m_dow_ids[12]);
  DDX_Control(pDX, IDC_DOW_ID_14, m_dow_ids[13]);
  DDX_Control(pDX, IDC_DOW_ID_15, m_dow_ids[14]);
  DDX_Control(pDX, IDC_DOW_ID_16, m_dow_ids[15]);
  DDX_Control(pDX, IDC_DOW_ID_17, m_dow_ids[16]);
  DDX_Control(pDX, IDC_DOW_ID_18, m_dow_ids[17]);
  DDX_Control(pDX, IDC_DOW_ID_19, m_dow_ids[18]);
  DDX_Control(pDX, IDC_DOW_ID_20, m_dow_ids[19]);
  DDX_Control(pDX, IDC_DOW_ID_21, m_dow_ids[20]);
  DDX_Control(pDX, IDC_DOW_ID_22, m_dow_ids[21]);
  DDX_Control(pDX, IDC_DOW_ID_23, m_dow_ids[22]);
  DDX_Control(pDX, IDC_DOW_ID_24, m_dow_ids[23]);
  DDX_Control(pDX, IDC_DOW_ID_25, m_dow_ids[24]);
  DDX_Control(pDX, IDC_DOW_ID_26, m_dow_ids[25]);
  DDX_Control(pDX, IDC_DOW_ID_27, m_dow_ids[26]);
  DDX_Control(pDX, IDC_DOW_ID_28, m_dow_ids[27]);
  DDX_Control(pDX, IDC_DOW_ID_29, m_dow_ids[28]);
  DDX_Control(pDX, IDC_DOW_ID_30, m_dow_ids[29]);
  DDX_Control(pDX, IDC_DOW_ID_31, m_dow_ids[30]);
  DDX_Control(pDX, IDC_DOW_ID_32, m_dow_ids[31]);
  //}}AFX_DATA_MAP
  }


BEGIN_MESSAGE_MAP(TempsDlg, CDialog)
  //{{AFX_MSG_MAP(TempsDlg)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_01, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_02, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_03, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_04, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_05, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_06, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_07, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_08, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_09, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_10, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_11, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_12, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_13, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_14, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_15, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_16, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_17, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_18, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_19, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_20, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_21, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_22, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_23, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_24, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_25, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_26, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_27, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_28, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_29, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_30, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_31, OnEnableTemp)
  ON_BN_CLICKED(IDC_ENABLE_TEMP_32, OnEnableTemp)
  ON_BN_CLICKED(IDC_REFRESH, OnRebootToRedetect)
  ON_BN_CLICKED(IDC_ALL_ON, OnAllOn)
  ON_BN_CLICKED(IDC_ALL_OFF, OnAllOff)
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDOK, OnClose)
  ON_WM_CANCELMODE()
  ON_WM_CAPTURECHANGED()
  ON_WM_TIMER()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// TempsDlg message handlers
/////////////////////////////////////////////////////////////////////////////
BOOL TempsDlg::Create()
  {
  return CDialog::Create(m_nID, m_pParent);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::PostNcDestroy()
  {
  delete this;
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnClose() 
  {
  ((CMy533I2C_WinTestDlg*)m_pParent)->TempsDlg_Done();
  }
/////////////////////////////////////////////////////////////////////////////
//  Parameters: int iTimeInterval - timer resolution in miliseconds.
//  max resolution is 55 ms.
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::StartTimer (int iTimeInterval)
  {
  // here we go...
  SetTimer (ID_TIMER2, iTimeInterval, NULL);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::StopTimer (void)
  {
  // kill the timer
  KillTimer (ID_TIMER2);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnTimer(UINT nIDEvent) 
  {
  if (nIDEvent == ID_TIMER2)
    {
    //Blank any displays that have not been updated in
    //the last 1.2 seconds.
    int
      i;
    for(i=0;i<=31;i++)
      {
      if(time_since_new_data[i])
        {
        time_since_new_data[i]--;
        if(!time_since_new_data[i])
          {
          m_deg_c_temps[i].SetWindowText(" - - ");
          m_deg_f_temps[i].SetWindowText(" - - ");
          }
        }
      }
    }
  // default processing
  CDialog::OnTimer(nIDEvent);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnReceivedTempReport(COMMAND_PACKET *packet)
  {
  double
    degc;
  degc=(*(short *)&(packet->data[1]))/16.0;

  //This logs the temperature
  ((CMy533I2C_WinTestDlg*)m_pParent)->log_temp(packet->data[0],
                                            degc,
                                            packet->data[3]);

  double
    degf;
  degf=(degc*9.0)/5.0+32.0;
  char
    deg_c_string[20];
  char
    deg_f_string[20];
  if(packet->data[3]==0)
    {
    strcpy(deg_c_string,"BAD");
    strcpy(deg_f_string,"CRC!");
    }
  else
    {
    sprintf(deg_c_string,"%9.4f",degc);
    sprintf(deg_f_string,"%9.4f",degf);
    }

  //1/10 of a second * 15 = 1.2 sec
  time_since_new_data[packet->data[0]]=12;

  m_deg_c_temps[packet->data[0]].SetWindowText(deg_c_string);
  m_deg_f_temps[packet->data[0]].SetWindowText(deg_f_string);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnReceivedSensorID(COMMAND_PACKET *packet)
  {
  //If the device is a 0x22 or 0x28, enable
  //temperature reporting, otherwise disable
  if((packet->data[1]!=0x22)&&
     (packet->data[1]!=0x28))
    {
    m_deg_c_temps[packet->data[0]].SetWindowText(" x x ");
    m_deg_f_temps[packet->data[0]].SetWindowText(" x x ");
    m_enable_temps[packet->data[0]].EnableWindow(FALSE);
    }
  else
    m_enable_temps[packet->data[0]].EnableWindow(TRUE);

  //Update the ID string even if it is not a sensor, but not
  //if they are all 0.
  if((packet->data[1]==0)&&
     (packet->data[2]==0)&&
     (packet->data[3]==0)&&
     (packet->data[4]==0)&&
     (packet->data[5]==0)&&
     (packet->data[6]==0)&&
     (packet->data[7]==0)&&
     (packet->data[8]==0))
    m_dow_ids[packet->data[0]].SetWindowText(" -  - ");
  else
    {
    char
      dow_id_string[30];
    sprintf(dow_id_string,
            "%02X%02X%02X%02X%02X%02X%02X%02X",
            packet->data[1],
            packet->data[2],
            packet->data[3],
            packet->data[4],
            packet->data[5],
            packet->data[6],
            packet->data[7],
            packet->data[8]);
    m_dow_ids[packet->data[0]].SetWindowText(dow_id_string);
    }

  if(packet->data[0]==31)
    {
    //We have all the IDs back from the module.
    //If this refresh was in response to our reboot
    //command, turn all the sensors on.
    if(boot_is_at_our_request)
      {
      boot_is_at_our_request=0;
      OnAllOn();
      }
    else
      {
      //We did not request a reboot, so just recall the currently
      //reporting sensors from the LCD module.
      COMMAND_PACKET
        reporting_state_request_packet;
      //Send the next query.
      reporting_state_request_packet.command=30;
      reporting_state_request_packet.data_length=0;
      //Send the packet to the module
      ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&reporting_state_request_packet);
      }
    }
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnEnableTemp(void) 
  {
  COMMAND_PACKET
    packet;
  packet.command=19; //Set Temp Reporting

  //single bit representing the sensor we are on
  unsigned int
    bit_mask;
  bit_mask=0x0001;

  //composite mask sent to the LCD module
#define REPORT_ENABLE_MASK (*((unsigned int *)packet.data))
  REPORT_ENABLE_MASK=0;

  int
    sensor;
  for(sensor=0;sensor<=31;sensor++)
    {
    if(m_enable_temps[sensor].GetCheck())
      REPORT_ENABLE_MASK|=bit_mask;
    bit_mask<<=1;
    }

  packet.data_length=4;
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnRebootToRedetect(void)
  {
  int
    sensor;
  for(sensor=0;sensor<=31;sensor++)
    m_dow_ids[sensor].SetWindowText(" -  - ");

  COMMAND_PACKET
    reboot_packet;
  //Send the next packet.
  reboot_packet.command=5;
  reboot_packet.data[0]=8;
  reboot_packet.data[1]=18;
  reboot_packet.data[2]=99;
  reboot_packet.data_length=3;
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&reboot_packet);

  //Remember that we kicked the module
  boot_is_at_our_request=1;

  //Tell the main window it is waiting for the module to come up. It will
  //call our LCDModuleBootComplete() when it is done.
  ((CMy533I2C_WinTestDlg*)m_pParent)->update_state=UPDATE_STATE_VERSION;
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::LCDModuleBootComplete(void)
  {
  //The main window has finished booting. Start our
  //ID refresh process.
  RefreshIDs() ;
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::RefreshIDs(void) 
  {
  COMMAND_PACKET
    next_request_packet;
  int
    i;
  for(i=0;i<=31;i++)
    {
    //Send query.
    next_request_packet.command=18;
    next_request_packet.data[0]=i;
    next_request_packet.data_length=1;
    //Send the packet to the module
    ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&next_request_packet);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnAllOn(void) 
  {
  int
    i;
  for(i=0;i<=31;i++)
    {
    //Enable the sensor, but only if the ID is 22 or 28
    char
      dow_id_string[3];
    m_dow_ids[i].GetWindowText(dow_id_string,3);
    if((dow_id_string[0]=='2')&&
       ((dow_id_string[1]=='2')||(dow_id_string[1]=='8')))
      m_enable_temps[i].SetCheck(1);
    }
  OnEnableTemp();
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnAllOff(void) 
  {
  int
    i;
  for(i=0;i<=31;i++)
    m_enable_temps[i].SetCheck(0);
  OnEnableTemp();
  }
/////////////////////////////////////////////////////////////////////////////
void TempsDlg::OnReceivedReportingStatus(COMMAND_PACKET *packet)
  {
  //single bit representing the sensor we are on
  unsigned int
    bit_mask;
  bit_mask=0x0001;

  //composite mask sent by the LCD module
#define REPORT_ENABLED_MASK (*((unsigned int *)(&packet->data[1])))

  int
    sensor;
  for(sensor=0;sensor<=31;sensor++)
    {
    m_enable_temps[sensor].SetCheck((REPORT_ENABLED_MASK&bit_mask)?1:0);
    bit_mask<<=1;
    }
  }
/////////////////////////////////////////////////////////////////////////////
